*! outdat.ado Version 1.3 ukohler@sowi.uni-mannheim.de 11-June-2002

* Change Log
*-----------

* Version 1.3: Set display formats before saving
* Version 1.2: if,in included
* Version 1.1: New Caller for external programs


program define outdat
version 7.0
syntax [varlist] using/ [in] [if] [, replace Type(string)] 

* Error-Checks
* ------------

capture which file
if _rc == 111 {
	di "{txt} transfer requires up to date stata -- See help {help update}"
}

preserve

* DEFAULT
* -------

if "`type'" == "" {local type "spss"}


* IF/IN
* -----

if "`if'" ~= "" | "`in'" ~= "" {
	keep `if' `in'
}

* SAVE DATA
* ---------
	
quietly compress
foreach var of local varlist {
    capture confirm byte `var'
    if _rc == 0 {
      format `var' %4.0g
    }
    capture confirm int `var'
    if _rc == 0 {
      format `var' %8.0g
    }
    capture confirm long `var'
    if _rc == 0 {
      format `var' %16.0g
    }
    capture confirm float `var'
    if _rc == 0 {
      format `var' %10.0g
    }
    capture confirm double `var'
    if _rc == 0 {
      format `var' %18.0g
    }
}

quietly	outfile `varlist' using `using'.dat, nolabel `replace'
di "{txt}Raw data written to {res} `using'.dat"

* DATA LIST
* ---------

outdat_`type' `varlist' using `using'
		
end
exit


Ulrich Kohler
University of Mannheim
Faculty of Social Sciences
68131 Mannheim
+49 (0621) 181-2053
