*! Stata-Syntax for outdat.ado 0.1 ukohler@sowi.uni-mannheim.de
* Change-log
* ----------

* Version 0.1: First draft
  
version 7.0
program define outdat_stata
syntax [varlist] using/ 

quietly {
  file open dofile using `using'.do, replace text write

  * DATA LIST
  * ---------

  file write dofile `"* Stata-commands to read and label `using'.dat"'
  file write dofile  /*
  */ _n _n `"infile `varlist' using "`using'.dat" "'

  * VARIABLE LABEL
  * --------------

  foreach var of varlist `varlist' {
    local varlab: variable label `var'
    file write dofile _n `"label variable `var' "`varlab'" "'
    local label: value label `var'
    if "`label'" ~= "" {
      file write dofile _n `"label value `var' `label' "'
    }
  }
  
  * VALUE LABEL
  * -----------
    
  tempfile labeldo
  label save _all using `labeldo'
  file open labels using `labeldo', read text
  file read labels line 
  while r(eof)==0 {
    file write dofile _n `"`line'"'
    file read labels line
  }
  file close labels
  file close dofile
  noi di "{txt}Stata-Commands written to {res} `using'.do"
}
		
end
exit


Ulrich Kohler
University of Mannheim
Faculty of Social Sciences
68131 Mannheim
+49 (0621) 181-2053
